---
layout: default
title: Home
nav_order: 1
description: "Robin is an XML/HTML parser and processing library for JavaScript and TypeScript."
permalink: /
---
{: .fs-7 }

<p align="center">
    <p align="center">
        <span class="fs-5 fw-350">An XML/HTML parser and processing library for JavaScript and TypeScript.</span>
        <img src="assets/images/robin_img.png">
    </p>
</p>
<p align="center">
    <a class="btn btn-blue fs-4 mb-4 mb-md-0 mr-2" href="docs/quick-start">Quick Start</a>
    <a class="btn fs-4 mb-4 mb-md-0 mr-2" href="https://github.com/ziord/robin">View it on Github</a>
</p>

---
## Overview

Robin is an XML parser and processing library that supports a sane version of HTML. It features a set of DOM utilities, including support for XPath 1.0 for interacting with and manipulating XML/HTML documents. Typical use-cases would be processing XML or HTML files, web scraping, etc.
Worthy to note that robin is a non-validating parser, which means that DTD structures are not used for validating the markup document.

## Installation

Simply run the following command in your terminal:
```
npm install @ziord/robin
```

## Quick Questions

If you have little questions that you feel isn't worth opening an issue for, use [the project's discussions.](https://github.com/ziord/robin/discussions)


## Contributing

Contributions are welcome! See the [contribution guidelines](https://github.com/ziord/robin/blob/master/CONTRIBUTING.md) to learn more. Thanks!


## Reporting Bugs/Requesting Features

Please [open an issue.](https://github.com/ziord/robin/issues) Checkout the [issue template.](https://github.com/ziord/robin/blob/master/.github/ISSUE_TEMPLATE)


## License

Robin is distributed under an [MIT license](https://github.com/ziord/robin/blob/master/LICENSE.txt).
